diff mbox series

[ovs-dev] utilities/bashcomp: Fix PS1 generation on new bash

Message ID d01ca95ca2979d191f4ebfe408f57d4e2407266b.1685120084.git.tredaelli@redhat.com
State Superseded
Headers show
Series [ovs-dev] utilities/bashcomp: Fix PS1 generation on new bash | expand

Checks

Context Check Description
ovsrobot/apply-robot warning apply and check: warning
ovsrobot/github-robot-_Build_and_Test success github build: passed
ovsrobot/intel-ovs-compilation fail test: fail

Commit Message

Timothy Redaelli May 26, 2023, 4:54 p.m. UTC
The current implementation used to extract PS1 prompt for ovs-vsctl is
broken on recent Bash releases.
Starting from Bash 4.4 it's possible to use @P expansion in order to get
the quoted PS1 directly.

This commit makes the 2 bash completion files to use @P expansion in order
to get the quoted PS1 on Bash >= 4.4.

Reported-at: https://bugzilla.redhat.com/2170344
Reported-by: Martin Necas <mnecas@redhat.com>
Signed-off-by: Timothy Redaelli <tredaelli@redhat.com>
---
 utilities/ovs-appctl-bashcomp.bash | 6 ++++++
 utilities/ovs-vsctl-bashcomp.bash  | 6 ++++++
 2 files changed, 12 insertions(+)
diff mbox series

Patch

diff --git a/utilities/ovs-appctl-bashcomp.bash b/utilities/ovs-appctl-bashcomp.bash
index 4384be8ae..dc5a9c7b4 100644
--- a/utilities/ovs-appctl-bashcomp.bash
+++ b/utilities/ovs-appctl-bashcomp.bash
@@ -223,6 +223,12 @@  printf_stderr() {
 # The code below is taken from Peter Amidon.  His change makes it more
 # robust.
 extract_bash_prompt() {
+    # On Bash 4.4+ just use the @P expansion
+    if ((BASH_VERSINFO[0] > 4 || (BASH_VERSINFO[0] == 4 && BASH_VERSINFO[1] >= 4))); then
+        _BASH_PROMPT="${PS1@P}"
+        return
+    fi
+
     local myPS1 v
 
     myPS1="$(sed 's/Begin prompt/\\Begin prompt/; s/End prompt/\\End prompt/' <<< "$PS1")"
diff --git a/utilities/ovs-vsctl-bashcomp.bash b/utilities/ovs-vsctl-bashcomp.bash
index fc8245bfb..6d7e1912d 100644
--- a/utilities/ovs-vsctl-bashcomp.bash
+++ b/utilities/ovs-vsctl-bashcomp.bash
@@ -413,6 +413,12 @@  _ovs_vsctl_get_PS1 () {
         return;
     fi
 
+    # On Bash 4.4+ just use the @P expansion
+    if ((BASH_VERSINFO[0] > 4 || (BASH_VERSINFO[0] == 4 && BASH_VERSINFO[1] >= 4))); then
+        printf '%s\n' "${PS1@P}"
+        return
+    fi
+
     # Original inspiration from
     # http://stackoverflow.com/questions/10060500/bash-how-to-evaluate-ps1-ps2,
     # but changed quite a lot to make it more robust.